#include "CDDB.au3"

;Example for CDDB.au3 - By GtaSpider

$aDGCD = DriveGetDrive("CDROM")
$sCombostring = ''
For $i = 1 To $aDGCD[0]
	$sCombostring &= StringUpper($aDGCD[$i]) & "|"
Next
StringTrimRight($sCombostring, 1)

GUICreate("Choose one drive", 150, 95, -1, -1, -1, 128);$WS_EX_TOOLWINDOW
$hComb_Drive = GUICtrlCreateCombo("", 10, 10, 50, 22)
GUICtrlSetData(-1, $sCombostring, $aDGCD[1])
$hBut_AskFreeDB = GUICtrlCreateButton("Ask FreeDB", 65, 10, 80, 22, 1) ; Style = $BS_DEFPUSHBUTTON
$hLab_Text = GUICtrlCreateLabel('Please choose one of the CD drives and click on "Ask FreeDB" to receive informations of the CD.', 10, 35, 130, 60)
GUISetState()

While 1
	Switch GUIGetMsg()
		Case $hBut_AskFreeDB
			$sLW = GUICtrlRead($hComb_Drive)
			GUICtrlDelete($hComb_Drive)
			GUICtrlDelete($hBut_AskFreeDB)
			GUICtrlSetData($hLab_Text, "Please wait until I try to get the CDDBQuery of " & $sLW & " and send the query to FreeDB. This may take a couple of seconds.")
			$hProg_Progress = GUICtrlCreateProgress(10, 10, 130, 14, 8);Stlye = $PBS_MARQUEE = 0x08 = 8
			GUICtrlSetColor(-1, 0)
			DllCall("UxTheme.dll", "int", "SetWindowTheme", "hwnd", GUICtrlGetHandle(-1), "wstr", "", "wstr", "")
			GUICtrlSetPos($hLab_Text, 10, 25, 130, 65)
			ExitLoop
		Case - 3 ;$GUI_EVENT_CLOSE = -3
			Exit
	EndSwitch
WEnd

Global $iProg = 0
AdlibRegister("_SetProg", 100)

$hTi = TimerInit()
$sQuery = _CDDBCreateQuery($sLW)
If @error Or (Not $sQuery) Then Exit MsgBox(16, "Error", "errorcode " & @error)
ConsoleWrite($sQuery & @CRLF)

$sDatabase = _FreeDBRecvDB($sQuery)
If @error Or (Not $sDatabase) Then Exit MsgBox(16, "Error", "2errorcode " & @error & @CRLF & $sDatabase)

If StringInStr($sDatabase, "211 Found inexact matches") Or StringInStr($sDatabase, "210 Found exact matches") Then
	GUICreate("More than just one found", 220, 185)
	$hListV = GUICtrlCreateListView("Founded matches", 10, 10, 200, 150)
	GUICtrlSendMsg(-1, 0x101E, 0, 180)
	$aSS = StringSplit($sDatabase, @CRLF, 1)
	For $i = 2 To $aSS[0] - 2
		GUICtrlCreateListViewItem($aSS[$i], $hListV)
		If $i = 2 Then GUICtrlSetState(-1,256);$GUI_FOCUS
	Next
	$hBut_OK = GUICtrlCreateButton("OK", 10, 165, 200, 15,1)
	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $hBut_OK
				$aRead = StringSplit(StringTrimRight(GUICtrlRead(GUICtrlRead($hListV)), 1), " ")
				GUIDelete()
				$read = "cddb read " & $aRead[1] & " " & $aRead[2] ; "cddb read categ discid"
				Local $hSocket
				TCPSend($hSocket, $read & @CRLF)
				$sDatabase = __TCPRecv2($hSocket)
				If @error Or (Not $sDatabase) Then Exit MsgBox(16, "Error", "2errorcode " & @error & @CRLF & $sDatabase)
				ExitLoop
			Case - 3 ;$GUI_EVENT_CLOSE = -3
				Exit
		EndSwitch
	WEnd
EndIf
$aCDInfos = _FreeDBRetCDInfos($sDatabase)
$aCDTracks = _FreeDBRetCDTracks($sDatabase)
$hTi = TimerDiff($hTi)
AdlibUnregister()
GUIDelete()

GUICreate("Informations of the CD tooks " & Round($hTi / 1000, 1) & " seconds", 420, 110)
GUICtrlCreateLabel("CD Title:", 8, 10, 50)
GUICtrlCreateInput($aCDInfos[1], 55, 8, 150, 18)
GUICtrlCreateLabel("CD Artist:", 8, 30, 50)
GUICtrlCreateInput($aCDInfos[0], 55, 28, 150, 18)
GUICtrlCreateLabel("CD Genre:", 8, 50, 50)
GUICtrlCreateInput($aCDInfos[2], 55, 48, 150, 18)
GUICtrlCreateLabel("CD Year:", 8, 70, 50)
GUICtrlCreateInput($aCDInfos[3], 55, 68, 150, 18)
GUICtrlCreateLabel("CD Extd:", 8, 90, 50)
GUICtrlCreateInput($aCDInfos[4], 55, 88, 150, 18)
$hListV = GUICtrlCreateListView("Title|Length|Position", 210, 8, 200, 99)
GUICtrlSendMsg(-1, 0x101E, 0, 90)
GUICtrlSendMsg(-1, 0x101E, 1, 35)
GUICtrlSendMsg(-1, 0x101E, 2, 35)
For $i = 0 To UBound($aCDTracks) - 1
	GUICtrlCreateListViewItem($aCDTracks[$i][0] & "|" & $aCDTracks[$i][1] & "|" & $aCDTracks[$i][2], $hListV)
Next


GUISetState()

While GUIGetMsg() <> -3
WEnd

Func _SetProg()
	$iProg += 1
	GUICtrlSetData($hProg_Progress, $iProg)
EndFunc   ;==>_SetProg
